代码随想录一刷记录Day44——leetcode1143.最长公共子序列 53. 最大子序和

前言

之前就有刷代码随想录,但奈何总是三天打鱼两天晒网,而且刷的也很囫囵吞枣,于是乎决定参加代码随想录训练营,准备精刷一遍,希望自己能坚持下去,结营后自己的算法水平能更上一个level,冲ing!

leetcode1143.最长公共子序列

题目链接1143.最长公共子序列

思路

本题和718. 最长重复子数组区别在于这里不要求是连续的。

  1. 确定dp数组以及下标的含义
    dpij:长度为0, i - 1的字符串text1与长度为0, j - 1的字符串text2的最长公共子序列为dpij
  2. 确定递推公式
    主要就是两大情况: text1i - 1 与 text2j - 1相同,text1i - 1 与 text2j - 1不相同
    如果text1i - 1 与 text2j - 1相同,那么找到了一个公共元素,所以dpij = dpi - 1j - 1 + 1;
    如果text1i - 1 与 text2j - 1不相同,那就看看text10, i - 2与text20, j - 1的最长公共子序列 和 text10, i - 1与text20, j - 2的最长公共子序列,取最大的。
    即:dpij = max(dpi - 1j, dpij - 1);
  3. dp数组如何初始化
    先看看dpi0应该是多少呢?text10, i-1和空串的最长公共子序列自然是0,所以dpi0 = 0;同理dp0j也是0。
  4. 确定遍历顺序
    从前向后,从上到下来遍历这个矩阵。dptext1.size()text2.size()为最终结果

代码

cpp 复制代码
class Solution {
public:
    int longestCommonSubsequence(string text1, string text2) {
        vector<vector<int>> dp(text1.size() + 1, vector<int>(text2.size() + 1, 0));
        for (int i = 1; i <= text1.size(); i++) {
            for (int j = 1; j <= text2.size(); j++) {
                if (text1[i - 1] == text2[j - 1]) {
                    dp[i][j] = dp[i - 1][j - 1] + 1;
                } else {
                    dp[i][j] = max(dp[i - 1][j], dp[i][j - 1]);
                }
            }
        }
        return dp[text1.size()][text2.size()];        
    }
};

leetcode53. 最大子序和

题目链接leetcode53. 最大子序和

思路

  1. 确定dp数组以及下标的含义
    dpi:包括下标i(以numsi为结尾)的最大连续子序列和为dpi。
  2. 确定递推公式
    dpi只有两个方向可以推出来:
    dpi - 1 + numsi,即:numsi加入当前连续子序列和
    numsi,即:从头开始计算当前连续子序列和
    一定是取最大的,所以dpi = max(dpi - 1 + numsi, numsi);
  3. dp数组如何初始化
    根据dpi的定义,很明显dp0应为nums0即dp0 = nums0。
  4. 确定遍历顺序
    递推公式中dpi依赖于dpi - 1的状态,需要从前向后遍历。
  5. 打印dp数组
    注意最后的结果可不是dpnums.size() - 1。要找最大的连续子序列,就应该找每一个i为终点的连续最大子序列。
    所以在递推公式的时候,可以直接选出最大的dpi。

代码

cpp 复制代码
class Solution {
public:
    int maxSubArray(vector<int>& nums) {
        if (nums.size() == 0) return 0;
        vector<int> dp(nums.size());
        dp[0] = nums[0];
        int result = dp[0];
        for (int i = 1; i < nums.size(); i++) {
            dp[i] = max(dp[i - 1] + nums[i], nums[i]); // 状态转移公式
            if (dp[i] > result) result = dp[i]; // result 保存dp[i]的最大值
        }
        return result;      
    }
};

leetcode

题目链接

思路

代码

相关推荐
zyl76513 小时前
FlashAttention 详解:从 GPU 硬件、普通 Attention 到分块计算与 Online Softmax
算法
爱读书的小胖17 小时前
LeetCode 122:买卖股票的最佳时机 II(C)解题分析
算法
结局无敌17 小时前
React Native for OpenHarmony 实战:三方库 react-native-modal-dialog 的鸿蒙化适配指南
深度学习·算法·react native·react.js·harmonyos
OPEN-F18 小时前
ROS2系列教程:上位机建图与导航(原理综合)
算法·机器人
weixin_3077791318 小时前
C++代码实现MATLAB中的fitrtree函数功能
开发语言·c++·算法·matlab
AI wins18 小时前
c++新增頭文件
c++
Shadow(⊙o⊙)18 小时前
仿muduo实现高并发服务器——事件就绪管理Channel.hpp
服务器·c++
tomwang032218 小时前
路径优化建模、优化算法分类及工程化小结
算法·数学建模·分类
小羊没烦恼!18 小时前
Ajax与JSON的一些总结
android·java·前端·数据库·mysql·算法·okhttp
by2099918 小时前
哈希表——快速找到数据:冲突、删除与扩容的实现
数据结构·c++·哈希算法·散列表